' PropBASIC demo program
' This program will show how to use TASKs to run code in seperate cogs.
'  This program uses two TASKs. One toggles (flashes) a pin,
'  The other receives a serial character from the programming port.
' Note that ONLY HUB variables are common to the main program, as well
'  as all tasks. The "normal" long variables are stored in cog memory so they
'  are not seen in other tasks (cogs).
'
' When this program is compiled it will create three output files.
'  test.spin - This is the main program to be loaded into the Propeller IDE
'  flash.spin - This is the object code for the task "Flash"
'  serial.spin - This is the object code for the task "Serial"
'
DEVICE P8X32A, XTAL1, PLL16X
FREQ 80_000_000

' Define CONs
Baud CON "T115200"


' Define PINs
SOutPin  PIN 30 LOW
SInPin   PIN 31 INPUT ' Used in TASK Serial


' Define HUB variables
led     HUB BYTE = 255
serChar HUB WORD = 256


' Define DATA (DATA, WDATA, LDATA)


' Define TASKs
Flash    TASK
Serial   TASK


' Define variables (LONGs only)
temp   VAR LONG
char   VAR LONG

PROGRAM Start

Start:
  PAUSE 100 ' Give tasks time to start
  DO
    FOR temp = 16 TO 23

      ' Exersise Flash task
      WRBYTE led,temp

      ' Exersise Serial Task
      RDWORD serChar, char
      IF char < 256 THEN
        WRWORD serChar, 256 ' Signal that we have recieved this char
        SEROUT sOutPin, Baud, char
      ENDIF

      PAUSE 200

    NEXT
  LOOP
END


TASK Flash
  pinNum VAR LONG
  DO
    RDBYTE Led, pinNum
    IF pinNum < 32 THEN
      HIGH pinNum
      PAUSE 40
      LOW pinNum
      PAUSE 40
    ENDIF
  LOOP
ENDTASK


TASK Serial
  temp     VAR LONG
  DO
    SERIN SInPin, Baud, temp
    WRWORD serChar, temp
  LOOP
ENDTASK


