''  *** COMPILED WITH PropBasic VERSION 0.00.16  10/14/2009 ***
                                                             '' PropBASIC demo program
                                                             '' This program will show how to use TASKs to run code in seperate cogs.
                                                             ''  This program uses two TASKs. One toggles (flashes) a pin,
                                                             ''  The other receives a serial character from the programming port.
                                                             '' Note that ONLY HUB variables are common to the main program, as well
                                                             ''  as all tasks. The "normal" long variables are stored in cog memory so they
                                                             ''  are not seen in other tasks (cogs).
                                                             ''
                                                             '' When this program is compiled it will create three output files.
                                                             ''  test.spin - This is the main program to be loaded into the Propeller IDE
                                                             ''  flash.spin - This is the object code for the task "Flash"
                                                             ''  serial.spin - This is the object code for the task "Serial"
                                                             ''


CON                                                          'DEVICE P8X32A, XTAL1, PLL16X
  _ClkMode = XTAL1 + PLL16X                                 

  _XInFreq =   5000000                                       'FREQ 80_000_000


                                                             '' Define CONs
' Baud          =  "T115200"                                 'Baud CON "T115200"



                                                             '' Define PINs
' SOutPin  PIN 30 LOW                                        'SOutPin  PIN 30 LOW

' SInPin   PIN 31 INPUT ' Used in TASK Serial                'SInPin   PIN 31 INPUT ' Used in TASK Serial



                                                             '' Define HUB variables
' VAR BYTE led                                               'led     HUB BYTE = 255

' VAR WORD serChar                                           'serChar HUB WORD = 256



                                                             '' Define DATA (DATA, WDATA, LDATA)


                                                             '' Define TASKs
OBJ Flash: "Flash.spin"                                      'Flash    TASK

OBJ Serial: "Serial.spin"                                    'Serial   TASK



                                                             '' Define variables (LONGs only)
' temp   VAR LONG                                            'temp   VAR LONG

' char   VAR LONG                                            'char   VAR LONG


PUB __Program                                                'PROGRAM Start
  FLASH.Init(@__DATASTART)                                  
  SERIAL.Init(@__DATASTART)                                 
  CogNew(@__Init, @__DATASTART)                             
                                                            
DAT                                                         
                org         0                               
__Init                                                      
                mov         dira,__InitDirA                 
                mov         outa,__InitOutA                 
                jmp         #Start                          


Start                                                        'Start:

                mov         __temp1,cnt                      '  PAUSE 100 ' Give tasks time to start
                adds        __temp1,_1mSec                  
                mov         __temp2,#100                    
__L0001                                                     
                waitcnt     __temp1,_1mSec                  
                djnz        __temp2,#__L0001                

__DO_1                                                       '  DO

                mov         temp,#16                         '    FOR temp = 16 TO 23
__FOR_temp_1                                                


                                                             '      ' Exersise Flash task
                mov         __temp1,#led_ofs                 '      WRBYTE led,temp
                add         __temp1,par                     
                wrbyte      temp,__temp1                    


                                                             '      ' Exersise Serial Task
                mov         __temp1,#serChar_ofs             '      RDWORD serChar, char
                add         __temp1,par                     
                rdword      char,__temp1                    

                cmps        char,#256 WZ, WC                 '      IF char < 256 THEN
    IF_AE       jmp         #__ELSE_1                       

                mov         __temp1,#serChar_ofs             '        WRWORD serChar, 256 ' Signal that we have recieved this char
                add         __temp1,par                     
                mov         __temp2,#256                    
                wrword      __temp2,__temp1                 

                mov         __temp1,SOutPin                  '        SEROUT sOutPin, Baud, char
                mov         __temp2,char                    
                or          __temp2,#256                    
                shl         __temp2,#1                      
                or          dira,__temp1                    
                mov         __temp3,#10                     
                mov         __temp4,_bitDelay               
                add         __temp4,cnt                     
__L0002                                                     
                shr         __temp2,#1 WC                   
                muxc        outa,__temp1                    
                waitcnt     __temp4,_bitDelay               
                djnz        __temp3,#__L0002                

__ELSE_1                                                     '      ENDIF
__ENDIF_1                                                   


                mov         __temp1,cnt                      '      PAUSE 200
                adds        __temp1,_1mSec                  
                mov         __temp2,#200                    
__L0003                                                     
                waitcnt     __temp1,_1mSec                  
                djnz        __temp2,#__L0003                


                adds        temp,#1                          '    NEXT
                cmps        temp,#23 WZ, WC                 
    IF_BE       jmp         #__FOR_temp_1                   

                jmp         #__DO_1                          '  LOOP
__LOOP_1                                                    

                jmp         #$                               'END



'**********************************************************************
__InitDirA       LONG %01000000_00000000_00000000_00000000
__InitOutA       LONG %00000000_00000000_00000000_00000000
SInPin           LONG -2147483648
_bitDelay        LONG 694
_1mSec           LONG 80000
SOutPin          LONG 1073741824

__REMAINDER
__TEMP1          RES 1
__TEMP2          RES 1
__TEMP3          RES 1
__TEMP4          RES 1
__TEMP5          RES 1
__PARAM1         RES 1
__PARAM2         RES 1
__PARAM3         RES 1
__PARAM4         RES 1
__PARAMCNT       RES 1
temp             RES 1
char             RES 1

FIT 492

CON
  LSBFIRST                         = 0
  MSBFIRST                         = 1
  MSBPRE                           = 0
  LSBPRE                           = 1
  MSBPOST                          = 2
  LSBPOST                          = 3
  led_ofs                          = 0
  serChar_ofs                      = 2

' TASK Flash                                                 'TASK Flash




' TASK Serial                                                'TASK Serial



DAT
__DATASTART
led              BYTE 255
serChar          WORD 256

